;***********************************************************************************************
;*          .   
;***********************************************************************************************
;        
;   . 170-250,      R2  U.                                       
; : PIC16F628A  PIC16F628
;       .
;      ,   
; 9(RB3) .         4.
;          . 10.
;        ,   .
; : 5  - VSS -5,
;           14 - VDD +5,
;           4  - MCLR     , 
;           16 - RA7   ,
;           9  - RB3    ( 4.),
;           8  - RB2     (  ).
;           15 - RA6  ,
;           17 - RA0   (U.).
;  : MPLAB IDE v8.30
;                 
;:   , , .
;***********************************************************************************************
            LIST      p=16F628A     
            #include  P16F628A.inc ; 
            __CONFIG  03F3CH       ;  , WDT ,
                                   ;  RC - , PWRT .
                                   ;  RA6    /.
;***********************************************************************************************
;* PO 
;***********************************************************************************************
temp        equ        70h         ;  
temp1       equ        71h         ;  
      
            org        2100h
            DE         "Shus Aleksey_UZBEKISTAN_g.CHIRCHIK_22.02.2010." 
;***********************************************************************************************
            org        0           ; 
;***********************************************************************************************
;***********************************************************************************************
;*  . 
;***********************************************************************************************
            clrf       INTCON      ;   .
            clrf       PORTB       ;  PORTB

            bsf        STATUS,RP0  ; 1- .
            movlw      b'10111111' ;   A
            movwf      TRISA       ; RA6  ,   .         
            movlw      b'11111111' ;   B,  
            movwf      TRISB       ;    .
            movlw      b'00000111' ;  TMR0=256, 
            movwf      OPTION_REG  ;     PORTB.  
            bcf        STATUS,RP0  ;    .
            clrf       PORTA       ;  PORTA
            bcf        PORTA,6
            call       pause       ;   



;***********************************************************************************************
;*  . 
;***********************************************************************************************
            movlw      b'00010010' ;     
            movwf      CMCON       ;  U., RA0 -  

;***********************************************************************************************
;                 
;***********************************************************************************************

u_max       bsf        STATUS,RP0  ; 1
            movlw      b'10001001' ;       
            movwf      VRCON       ; Uref=2,656v
            bcf        STATUS,RP0  ; 0
            call       sinhron     ;     U.
            call       plus_10ms   ;    10 -  U.
loop_max    clrwdt                 ;     
            btfsc      CMCON,6     ;   
            goto       off_max     ;  ,         
            goto       u_min       ;  ,      .
off_max     bcf        PORTA,6     ;   PORTB,7=0.
            call       gister_high ;      .    
            call       sinhron     ;     U.
            call       plus_10ms   ;    10 -  U.
            goto       loop_max    ;      . 

            
;***********************************************************************************************
;                 
;***********************************************************************************************

u_min       bsf        STATUS,RP0  ; 1
            movlw      b'10000011' ;       
            movwf      VRCON       ; Uref=1,719v  
            bcf        STATUS,RP0  ; 0
            call       sinhron     ;     U.
            call       plus_20ms   ;    20 -   U.
loop_min    clrwdt                 ;   
            btfss      CMCON,6     ;    . 
            goto       off_min     ;  , . . PORTB,7=0,
            bsf        PORTA,6     ;  ,   PORTB,7=1.
            goto       u_max       ;       
off_min     bcf        PORTA,6     ;  
            call       gister_low  ;          
            call       sinhron     ;     U.
            call       plus_10ms   ;    10 -  U.
            goto       loop_min    ;   .
            goto       u_max       ;      .

;**********************************************************************************************
;  
;**********************************************************************************************

gister_high bsf        STATUS,RP0  ; 1.
            movlw      b'10001000' ;       
            movwf      VRCON       ; Uref=2,5v.  
            bcf        STATUS,RP0  ; 0.
            goto       pause       ;   .
gister_low  bsf        STATUS,RP0  ; 1-   
            movlw      b'10000100' ; Uref=1,875v  
            movwf      VRCON
            bcf        STATUS,RP0  ; 0.
            goto       pause       ;   .
            


pause       btfss      PORTB,3     ;   RB3  .
            goto       zagruz_4min ;  4-  .
            goto       zagruz_5sec ;    -  5.
zagruz_4min movlw      .15          ;  .15  temp1.
            movwf      temp1 
            goto       $+3       
zagruz_5sec movlw      .1          ;    temp1
            movwf      temp1 
            
            btfsc      PORTB,2     ;   RB2   ,
            goto       $+6         ;   .
            movlw      .1          ; 
            movwf      temp1
            movlw      .1
            movwf      temp
            goto       $+3
            movlw      .76         ;  .76  temp
            movwf      temp  
loop        bsf        STATUS,RP0  ; 1
            bcf        INTCON,2    ;      TMR0
            clrwdt
            btfss      INTCON,2    ;       TMR0
            goto       $-2         ;  
            decfsz     temp        ;   temp   
            goto       loop        ;    .  temp=0,   
            decfsz     temp1       ;   temp1  . .  
            goto       loop        ;   ,   temp1=0,
            bcf        STATUS,RP0  ;   0  
            return                 ;   .

;**********************************************************************************************
;        U.
;**********************************************************************************************

sinhron     clrwdt                 ;   
            btfsc      PORTA,7     ;      U.
            goto       $-2
            clrwdt                 ;    
            btfss      PORTA,7     ;     U.
            goto       $-2
            return                 ;   
;**********************************************************************************************
;      +10
;**********************************************************************************************

plus_10ms   movlw      .13         ;  .13  temp1
            movwf      temp1       
            movlw      .255        ;  ffh  temp
            movwf      temp  
            clrwdt                 ;   
            decfsz     temp,f      ;  temp      .
            goto       $-1         ;  temp=0,
            decfsz     temp1,f     ;  temp1,   temp1=0,
            goto       $-5         
            return                 ;   .

;**********************************************************************************************
;      +20
;**********************************************************************************************
plus_20ms   movlw      .26         ;  .26  temp1
            movwf      temp1 
            movlw      .255        ;  ffh  temp
            movwf      temp  
            clrwdt                 ;   
            decfsz     temp,f      ;  temp.  temp=0, 
            goto       $-1
            decfsz     temp1,f     ;  temp1,   temp1=0,
            goto       $-5
            return                 ;   .

;***********************************************************************************************
            end                    ;  .